<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'AnimatedNumber',
  props: {
    number: {
      type: Number,
      required: true,
      default: 0,
    },
    delay: {
      type: Number,
      required: false,
      default: 0,
    },
    speed: {
      type: Number,
      required: false,
      default: 50,
      // speed: milliseconds
    },
    textVariant: {
      type: String,
      required: false,
      default: 'heading1',
    },
    threshold: {
      type: Number,
      required: false,
      default: 0,
      // threshold: intersection observer threshold
    },
  },
  data() {
    return {
      placeholderNumber: 0,
      observer: null,
    };
  },
  mounted() {
    const mediaQuery = window.matchMedia('(prefers-reduced-motion: reduce)');
    if (!mediaQuery.matches) {
      this.observer = new IntersectionObserver(this.animationHandler, {
        rootMargin: '0px',
        threshold: this.threshold,
      });
      const children = this.$refs.number as HTMLElement;
      this.observer.observe(children);
    } else {
      this.placeholderNumber = this.number;
    }
  },
  beforeDestroy() {
    this.observer.disconnect();
  },
  methods: {
    animationHandler(entries: any, observer) {
      entries.forEach((entry: any) => {
        const element = entry.target;

        if (entry.isIntersecting) {
          this.updateCount(element);
          observer.unobserve(element);
        }
      });
    },
    updateCount(element) {
      const endNbr = Number(element.getAttribute('data-target'));
      setTimeout(() => {
        this.increment(0, endNbr, element);
      }, this.delay);
    },
    increment(i, endNbr, element) {
      if (i <= endNbr) {
        element.innerHTML = i;
        setTimeout(() => {
          this.increment(i + 1, endNbr, element);
        }, this.speed);
      }
    },
  },
});
</script>

<template>
  <SlpTypography :variant="textVariant ?? 'heading1'" tag="p">
    <span ref="number" :data-target="number" class="animated-number">{{
      placeholderNumber
    }}</span
    ><span class="percent">%</span>
  </SlpTypography>
</template>

<style lang="scss" scoped></style>
